package wifi.rcc;
import wifi.rcc.R;
import wifi.rcc.WIFIRCCActivity.U_OnTouchListener;
import wifi.rcc.WIFIRCCActivity.D_OnTouchListener;
import wifi.rcc.WIFIRCCActivity.L_OnTouchListener;
import wifi.rcc.WIFIRCCActivity.R_OnTouchListener;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;
import java.util.Enumeration;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.StrictMode;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.view.KeyEvent;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.MotionEvent;
import android.view.View.OnCreateContextMenuListener;
import android.view.View.OnLongClickListener;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.ImageButton;
import android.widget.Toast;


import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


public class WIFIRCCActivity extends Activity {
    /** Called when the activity is first created. */
	
	private Button startButton;
	private ImageButton U_Button;
	private ImageButton D_Button;
	private ImageButton L_Button;
	private ImageButton R_Button;
	private ImageButton SP_Button;
	private SeekBar speed;
	private EditText IPText;	
	private TextView recvText;
	private TextView detText;
	private int OUTPUT;
	
	private Context mContext;
	private boolean isConnecting = false;
	private boolean onflag = false;
	
	private Thread mThreadClient = null;
	private Socket mSocketClient = null;
	static BufferedReader mBufferedReaderServer	= null;
	static PrintWriter mPrintWriterServer = null;
	static BufferedReader mBufferedReaderClient	= null;
	static PrintWriter mPrintWriterClient = null;
	private  String recvMessageClient = "";
	private  String recvMessageServer = "";
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        mContext = this;
        
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()        
        .detectDiskReads()        
        .detectDiskWrites()        
        .detectNetwork()   // or .detectAll() for all detectable problems       
        .penaltyLog()        
        .build());        
        StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder()        
        .detectLeakedSqlLiteObjects()     
        .penaltyLog()        
        .penaltyDeath()        
        .build()); 
        
        IPText= (EditText)findViewById(R.id.IPText);
        IPText.setText("rowin.ticp.net:502");
        startButton= (Button)findViewById(R.id.StartConnect);
        startButton.setOnClickListener(StartClickListener); 
                       
        U_Button= (ImageButton)findViewById(R.id.u);
        U_Button.setOnTouchListener(new U_OnTouchListener());
        //U_Button.setOnClickListener(U_ClickListener); 
        
        D_Button= (ImageButton)findViewById(R.id.d);
        D_Button.setOnTouchListener(new D_OnTouchListener());
        
        L_Button= (ImageButton)findViewById(R.id.l);
        L_Button.setOnTouchListener(new L_OnTouchListener());
        
        R_Button= (ImageButton)findViewById(R.id.r);
        R_Button.setOnTouchListener(new R_OnTouchListener());
        
        SP_Button= (ImageButton)findViewById(R.id.sp);
        SP_Button.setOnTouchListener(new SP_OnTouchListener());
        
        recvText= (TextView)findViewById(R.id.RecvText);       
        recvText.setMovementMethod(ScrollingMovementMethod.getInstance()); 
        detText= (TextView)findViewById(R.id.textView1);
        detText.setText(" ");
               
    }
    
    class U_OnTouchListener implements OnTouchListener
    {
      @Override
      public boolean onTouch(View v, MotionEvent event)
      {
        if (event.getAction() == MotionEvent.ACTION_DOWN)//
           {
        	if ( isConnecting && mSocketClient!=null) 
			{
        		OUTPUT=OUTPUT|0x06;//0110B:O2O3ߵƽ
        		String output ="01 05 00 00 FF 00";
        		U_Button.setBackgroundResource(R.drawable.d);
        		detText.setText("Forward");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
            }  
       if (event.getAction() == MotionEvent.ACTION_UP)//
          {
    	   if ( isConnecting && mSocketClient!=null) 
			{
       		OUTPUT=OUTPUT&0xF0;//0000B:O1O2O3O4͵ƽ
       		String output ="OUTPUT "+OUTPUT;
       		U_Button.setBackgroundResource(R.drawable.w);
       		detText.setText("Stop");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
          }
       //true  ʾ¼ϣжϵͳԸ¼Ĵfalse ϵͳͬʱӦ¼
       return true;
      }
    }
 
    
    ////////////////////////////////////
    class D_OnTouchListener implements OnTouchListener
    {
      @Override
      public boolean onTouch(View v, MotionEvent event)
      {
        if (event.getAction() == MotionEvent.ACTION_DOWN)//
           {
        	if ( isConnecting && mSocketClient!=null) 
			{
        		OUTPUT=OUTPUT|0x09;//1001B:O1O4ߵƽ
        		String output ="OUTPUT "+OUTPUT;
        		D_Button.setBackgroundResource(R.drawable.d);
        		detText.setText("Backward");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
            }  
       if (event.getAction() == MotionEvent.ACTION_UP)//
          {
    	   if ( isConnecting && mSocketClient!=null) 
			{
       		OUTPUT=OUTPUT&0xF0;//0000B:O1O2O3O4͵ƽ
       		String output ="OUTPUT "+OUTPUT;
       		D_Button.setBackgroundResource(R.drawable.w);
       		detText.setText("Stop");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
          }
       //true  ʾ¼ϣжϵͳԸ¼Ĵfalse ϵͳͬʱӦ¼
       return true;
      }
    }
    class L_OnTouchListener implements OnTouchListener
    {
      @Override
      public boolean onTouch(View v, MotionEvent event)
      {
        if (event.getAction() == MotionEvent.ACTION_DOWN)//
           {
        	if ( isConnecting && mSocketClient!=null) 
			{
        		OUTPUT=OUTPUT|0x04;//0100B:O3ߵƽ
        		String output ="OUTPUT "+OUTPUT;
        		L_Button.setBackgroundResource(R.drawable.d);
        		detText.setText("Left");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
            }  
       if (event.getAction() == MotionEvent.ACTION_UP)//
          {
    	   if ( isConnecting && mSocketClient!=null) 
			{
       		OUTPUT=OUTPUT&0xF0;//0000B:O1O2O3O4͵ƽ
       		String output ="OUTPUT "+OUTPUT;
       		L_Button.setBackgroundResource(R.drawable.w);
       		detText.setText("Stop");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
          }
       //true  ʾ¼ϣжϵͳԸ¼Ĵfalse ϵͳͬʱӦ¼
       return true;
      }
    }
    class R_OnTouchListener implements OnTouchListener
    {
      @Override
      public boolean onTouch(View v, MotionEvent event)
      {
        if (event.getAction() == MotionEvent.ACTION_DOWN)//
           {
        	if ( isConnecting && mSocketClient!=null) 
			{
        		OUTPUT=OUTPUT|0x02;//0010B:O2ߵ͵ƽ
        		String output ="OUTPUT "+OUTPUT;
        		R_Button.setBackgroundResource(R.drawable.d);
        		detText.setText("Right");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
            }  
       if (event.getAction() == MotionEvent.ACTION_UP)//
          {
    	   if ( isConnecting && mSocketClient!=null) 
			{
       		OUTPUT=OUTPUT&0xF0;//0000B:O1O2O3O4͵ƽ
       		String output ="OUTPUT "+OUTPUT;
       		R_Button.setBackgroundResource(R.drawable.w);
       		detText.setText("Stop");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//͵ź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
          }
       //true  ʾ¼ϣжϵͳԸ¼Ĵfalse ϵͳͬʱӦ¼
       return true;
      }
    }
    class SP_OnTouchListener implements OnTouchListener
    {
      @Override
      public boolean onTouch(View v, MotionEvent event)
      {
        if (event.getAction() == MotionEvent.ACTION_DOWN)//
           {
        	if ( isConnecting && mSocketClient!=null) 
			{
        		String output ="PWM 1 100 100";//PWM1ߵƽ
        		SP_Button.setBackgroundResource(R.drawable.d);
        		detText.setText("Speeker");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//ͷź
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
            }  
       if (event.getAction() == MotionEvent.ACTION_UP)//
          {
    	   if ( isConnecting && mSocketClient!=null) 
			{
       		String output ="PWM 1 100 0";//PWM1͵ƽ
       		SP_Button.setBackgroundResource(R.drawable.w);
       		detText.setText("Stop");
					try 
					{				    	
				    	mPrintWriterClient.print(output);//رշ
				    	mPrintWriterClient.flush();				    	
					}
					catch (Exception e) 
					{
						// TODO: handle exception
						Toast.makeText(mContext, "no connect" + e.getMessage(), Toast.LENGTH_SHORT).show();
					}													
			}
			else
			{
				Toast.makeText(mContext, "no connect", Toast.LENGTH_SHORT).show();
			}		
          }
       //true  ʾ¼ϣжϵͳԸ¼Ĵfalse ϵͳͬʱӦ¼
       return true;
      }
    }
    ///////////////////////
    
    ///////////////////////
    private OnClickListener StartClickListener = new OnClickListener() {
		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub				
			if (isConnecting) 
			{				
				isConnecting = false;
				try {
					if(mSocketClient!=null)
					{
						mSocketClient.close();
						mSocketClient = null;
						
						mPrintWriterClient.close();
						mPrintWriterClient = null;
					}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				mThreadClient.interrupt();
				
				startButton.setText("connect");					
				IPText.setEnabled(true);		
				recvText.setText("information:\n");
			}
			else
			{				
				isConnecting = true;
				startButton.setText("disconnect");						
				IPText.setEnabled(false);
				
				mThreadClient = new Thread(mRunnable);
				mThreadClient.start();				
			}
		}
	};	
	//߳:Ϣ
	private Runnable	mRunnable	= new Runnable() 
	{
		public void run()
		{
			String msgText =IPText.getText().toString();
			if(msgText.length()<=0)
			{
				//Toast.makeText(mContext, "IPΪգ", Toast.LENGTH_SHORT).show();
				recvMessageClient = "IP can't be empty!\n";//Ϣ
				Message msg = new Message();
                msg.what = 1;
				mHandler.sendMessage(msg);
				return;
			}
			int start = msgText.indexOf(":");
			if( (start == -1) ||(start+1 >= msgText.length()) )
			{
				recvMessageClient = "IP address is error!\n";//Ϣ
				Message msg = new Message();
                msg.what = 1;
				mHandler.sendMessage(msg);
				return;
			}
			String sIP = msgText.substring(0, start);
			String sPort = msgText.substring(start+1);
			int port = Integer.parseInt(sPort);				
			
			Log.d("gjz", "IP:"+ sIP + ":" + port);		

			try 
			{				
				//ӷ
				mSocketClient = new Socket(sIP, port);	//portnum
				//ȡ롢
				mBufferedReaderClient = new BufferedReader(new InputStreamReader(mSocketClient.getInputStream()));
				
				mPrintWriterClient = new PrintWriter(mSocketClient.getOutputStream(), true);
				
				recvMessageClient = "connected to server!\n";//Ϣ
				Message msg = new Message();
                msg.what = 1;
				mHandler.sendMessage(msg);		
				//break;
			}
			catch (Exception e) 
			{
				recvMessageClient = "connecting IP is error:" + e.toString() + e.getMessage() + "\n";//Ϣ
				Message msg = new Message();
                msg.what = 1;
				mHandler.sendMessage(msg);
				return;
			}			

			char[] buffer = new char[256];
			int count = 0;
			while (isConnecting)
			{
				try
				{
					//if ( (recvMessageClient = mBufferedReaderClient.readLine()) != null )
					if((count = mBufferedReaderClient.read(buffer))>0)
					{						
						recvMessageClient = getInfoBuff(buffer, count) + "\n";//Ϣ
						Message msg = new Message();
		                msg.what = 1;
						mHandler.sendMessage(msg);
					}
				}
				catch (Exception e)
				{
					recvMessageClient = "Receive Error :" + e.getMessage() + "\n";//Ϣ
					Message msg = new Message();
	                msg.what = 1;
					mHandler.sendMessage(msg);
				}
			}
		}
	};
	
	Handler mHandler = new Handler()
	{										
		  public void handleMessage(Message msg)										
		  {											
			  super.handleMessage(msg);			
			  if(msg.what == 0)
			  {
				  recvText.append("Server: "+recvMessageServer);	// ˢ
			  }
			  else if(msg.what == 1)
			  {
				  recvText.append("Client: "+recvMessageClient);	// ˢ

			  }
		  }									
	 };
		
		private String getInfoBuff(char[] buff, int count)
		{
			char[] temp = new char[count];
			for(int i=0; i<count; i++)
			{
				temp[i] = buff[i];
			}
			return new String(temp);
		}
				
		public void onDestroy() {
			super.onDestroy();
			if (isConnecting) 
			{				
				isConnecting = false;
				try {
					if(mSocketClient!=null)
					{
						mSocketClient.close();
						mSocketClient = null;
						
						mPrintWriterClient.close();
						mPrintWriterClient = null;
					}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				mThreadClient.interrupt();
			}

		}
}